 /*
  * header file for spline code
  */

/* import standards */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif

/* define statements. The fortrn code hardwires values of 1001, 10001, and 10 for various arrays */
#define MAXSPLINE 1001
#define MINSPLINE 10

/* a common type. The fortran code uses a hated common block called mspdat. To replicate that, just keep passing a variable of this type to each routine */
/*
typedef struct {
        int nn[MINSPLINE];
        int ndim[MINSPLINE];
        double xx[MAXSPLINE][MINSPLINE];
        double sc[4][MAXSPLINE][MINSPLINE];
        double scc[5][MAXSPLINE][MINSPLINE];
} SPLINECOMMON;
*/
typedef struct {
	int *nn;
	int *ndim;
	double **xx;
	double ***sc;
	double ***scc;
} SPLINECOMMON;



/* Function prototypes */
double fsig(double a, double b, double c);
int mspline(int ip, int n, double *x, double *y, int ind1, double d1, int ind2, double d2, SPLINECOMMON *splineCommon);
int msplint(int ip, double sa, double sb, double *sint, SPLINECOMMON *splineCommon);
int msplder(int ip, double xt, double *s, double *sd, double *sdd, SPLINECOMMON *splineCommon);
void cubspl(double *tau, double **c, int n, int ibcbeg, int ibcend, SPLINECOMMON *splineCommon);



